// Config du PIC18F45K22 en mode TX
// Dernre mise  jour le 06/12/20
// Electronique71.com

#define TRUE 1
#define FALSE 0

// Dclaration des variables
// sTab qui comporte 9 lements et avec un total de 4 caractre + le dernier caractre "0" ce qui donne 5 pour la fin de ligne
const unsigned short _MAX_STRING_LENGTH = 5; // 4 + Le 5me caractre que nous devons obligatoirement ajouter
char sTab[9][_MAX_STRING_LENGTH] =  {"0x01", "0x02", "0x04", "0x08", "0x10", "0x20", "0x40", "0x80", "0x00"};

int bState_RB0 = TRUE;
int bState_RB1 = TRUE;
int bState_RB2 = TRUE;
int bState_RB3 = TRUE;
int bState_RB4 = TRUE;
int bState_RB5 = TRUE;
int bState_RB6 = TRUE;
int bState_RB7 = TRUE;

// Initialisation du PIC18F45K22
void init( )
{
   // =========== CONFIG DES ENTREES ===========
   TRISA = 0xC0;  // Config des entres RA6 et RA7 pour OSC 8Mhz
   ANSELA = 0x00; // On coupe toutes les entres analogiques
   PORTA = 0x00;

   TRISB = 0xFF;  // Config du PORTB en entre
   ANSELB = 0x00; // On coupe les entres analogiques
   PORTB = 0x00;

   TRISC = 0x80;  // Config du RC6 (TX) en sortie et RC7(RX) en entre
   ANSELC = 0x00; // On coupe les entres analogiques
   PORTC = 0x00;

   TRISD = 0x00;  // Config du PORTD en sorties
   ANSELD = 0x00; // On coupe les entres analogiques
   PORTD = 0x00;

   TRISE = 0x00;  // Config du PORTE en sorties
   ANSELE = 0x00; // On coupe les entres analogiques
   PORTE = 0x00;

   // =========== CONFIG PORT SERIE (MODE TX)===========

   TXEN_bit = 1; // On active la transmission
   SPEN_bit = 1;  // On active port srie (RX / TX)
   TX9_bit = 0; // Config transmission sur 9 bits

   UART1_Init(9600); // Initialisation  9600 baudes

   Delay_100ms; // On attend un peu que l'initialisation se termine

}

// Programme principal
void main()
{
    init(); // Initialisation du PIC 18F45K22

    while (1)
    {
          // Port 0
           if ((RB0_bit == 1 ) && (bState_RB0 == TRUE))
           {
              UART1_Write_Text(sTab[0]);
              bState_RB0 = FALSE;
           }
           else if ((RB0_bit == 0 ) && (bState_RB0 == FALSE))
           {
              bState_RB0 = TRUE;
              UART1_Write_Text(sTab[8]);
           }

          // Port 1
          if ((RB1_bit == 1 ) && (bState_RB1 == TRUE))
           {
              UART1_Write_Text(sTab[1]);
              bState_RB1 = FALSE;
           }
           else if ((RB1_bit == 0 ) && (bState_RB1 == FALSE))
           {
              bState_RB1 = TRUE;
              UART1_Write_Text(sTab[8]);
           }

          // Port 2
          if ((RB2_bit == 1 ) && (bState_RB2 == TRUE))
           {
              UART1_Write_Text(sTab[2]);
              bState_RB2 = FALSE;
           }
           else if ((RB2_bit == 0 ) && (bState_RB2 == FALSE))
           {
              bState_RB2 = TRUE;
              UART1_Write_Text(sTab[8]);
           }

          // Port 3
          if ((RB3_bit == 1 ) && (bState_RB3 == TRUE))
           {
              UART1_Write_Text(sTab[3]);
              bState_RB3 = FALSE;
           }
           else if ((RB3_bit == 0 ) && (bState_RB3 == FALSE))
           {
              bState_RB3 = TRUE;
              UART1_Write_Text(sTab[8]);
           }

          // Port 4
          if ((RB4_bit == 1 ) && (bState_RB4 == TRUE))
           {
              UART1_Write_Text(sTab[4]);
              bState_RB4 = FALSE;
           }
           else if ((RB4_bit == 0 ) && (bState_RB4 == FALSE))
           {
              bState_RB4 = TRUE;
              UART1_Write_Text(sTab[8]);
           }

          // Port 5
          if ((RB5_bit == 1 ) && (bState_RB5 == TRUE))
           {
              UART1_Write_Text(sTab[5]);
              bState_RB5 = FALSE;
           }
           else if ((RB5_bit == 0 ) && (bState_RB5 == FALSE))
           {
              bState_RB5 = TRUE;
              UART1_Write_Text(sTab[8]);
           }

          // Port 6
          if ((RB6_bit == 1 ) && (bState_RB6 == TRUE))
           {
              UART1_Write_Text(sTab[6]);
              bState_RB6 = FALSE;
           }
           else if ((RB6_bit == 6 ) && (bState_RB6 == FALSE))
           {
              bState_RB6 = TRUE;
              UART1_Write_Text(sTab[8]);
           }

          // Port 7
          if ((RB7_bit == 1 ) && (bState_RB7 == TRUE))
           {
              UART1_Write_Text(sTab[7]);
              bState_RB7 = FALSE;
           }
           else if ((RB7_bit == 0 ) && (bState_RB7 == FALSE))
           {
              bState_RB7 = TRUE;
              UART1_Write_Text(sTab[8]);
           }
    }
}